//*********************************************************************************
//**
//** General purpose buttons made by J.G. Holstein @ 2017
//**
//** 
//** Copyright (c) 2019  J.G. Holstein  
//** This program is free software: you can redistribute it and/or modify
//** it under the terms of the GNU General Public License as published by
//** the Free Software Foundation, either version 3 of the License, or
//** (at your option) any later version.
//**
//** This program is distributed in the hope that it will be useful,
//** but WITHOUT ANY WARRANTY; without even the implied warranty of
//** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//** GNU General Public License for more details.
//**
//** You should have received a copy of the GNU General Public License
//** along with this program.  If not, see <http://www.gnu.org/licenses/>.
//**
//**  Platform........: Teensy 4.0 (http://www.pjrc.com)
//**
//** 
//**Version T_1.02 RA8875
//*********************************************************************************

//General purpose buttons

//*********************************************Buttons**********************************************
struct NewBut {short x; short y; short w; short h; short xoff; short font; String offtext; int offtxtcol; int offbutcol; String ontext; int ontxtcol; int onbutcol; short onoff;};
void ReadButtons(bool redraw)
{

tft.setFont(&Awesome_48);


    
    // Last button number used
    static short LastBut = 3;
    static short ButAction[4] = {0,0,0,0};
      static short Button[4] = {0,0,0,0};
      static String ButText[1];
 
    // See http://fontawesome.io/icons/ for the Symbol button code
    // x-position, y-position, width, height, x-offset, font_Awesome part (0xfff if it is a text button), offtext, offtxtcol, offbutcol, ontext, ontxtcol, onbutcol, onoff 

    static NewBut But_Param[4] = {
    /* Button 0*/{20, 350, 110, 110, 20, 0x100, char('a'), LTBLUE, DKGREEN, char('a'), BLUE, LTBLUE, 0}, // Accept button
    /* Button 1*/{20, 25, 110, 110, 20, 0x100, char('n'), LTBLUE, BLUE, char('n'), BLUE, LTBLUE, 0},     // Arrow up button
    /* Button 2*/{20, 187, 110, 110, 20, 0x100, char('o'), LTBLUE, BLUE, char('o'), BLUE, LTBLUE, 0},    // Arrow down button
    /* Button 3*/{675, 350, 110, 110, 20, 0x100, char('f'), LTBLUE, ORANGE, char('f'), BLUE, LTBLUE, 0}, // Exit menu
    
    };
   
    static short TouchZ ;
    tft.updateTS();
    TouchZ= tft.getTScoordinates(coordinates);
//Touchscreen
        
        //###### buttons  ######
        for (int i=0; i <= LastBut; i++){
        
           if (Button[i] == 0 || redraw)
           {
            if (ButAction[i] == 0){
                           
              TXTtestButton(But_Param[i].x, But_Param[i].y, But_Param[i].w, But_Param[i].h, But_Param[i].xoff, But_Param[i].font, But_Param[i].offtext, But_Param[i].onoff, But_Param[i].offtxtcol, But_Param[i].offbutcol);
             }
            Button[i] = 1;
            TouchZ =0;
           }
            if (Button[i] == 1 && TouchX > But_Param[i].x && TouchX < But_Param[i].x + But_Param[i].w && TouchY > But_Param[i].y && TouchY < But_Param[i].y + But_Param[i].h && TouchZ > 0){
            TXTtestButton(But_Param[i].x, But_Param[i].y, But_Param[i].w, But_Param[i].h, But_Param[i].xoff, But_Param[i].font, But_Param[i].ontext, But_Param[i].onoff, But_Param[i].ontxtcol,But_Param[i].onbutcol);

            Button[i] = 0;
            TouchZ =0;
            switch (i) {
              
              case 0: //setup page
              if (ButAction[0] == 0){
                  touch.enact = true;           
                  Button[1] = 0;
               } else {                                            
               // action
               }
              break;           
                case 1:  //help page
              if (ButAction[1] == 0){
                  touch.up = true;
                  Button[2] = 0;
              } else {
                // action
              }
              break;
                case 2:
              if (ButAction[2] == 0){
                  touch.down = true;
              } else {
                // action
              }
              break;           
               case 3:
              if  (ButAction[3] == 0){
                  touch.exit = true;
                  
               } else {
               // action
              }
              break;
            } 
            if (But_Param[i].onoff == 1) {ButAction[i] = 1 - ButAction[i];}
            
          }
     }
}
        

//##################################################################################################################################################################
//######                                Subroutine to draw a graphic button on the screen (See http://fontawesome.io/icons/)                                  ######
//##################################################################################################################################################################
void TXTtestButton(short x, short y, short w, short h, short xoff, short font, String text, short onoff, int txtcol, int butcol)
{

  static short yoff;
 
  if (font == 0x100) { yoff = (h - 32)/2 - 10; xoff = (w - text.length())/3.5;}
   
  tft.fillRoundRect(x, y, w, h, 20, butcol);
  tft.drawRoundRect(x, y, w, h, 20, WHITE);
  tft.setCursor(x + xoff,y + yoff);
  tft.setTextColor(txtcol);
  tft.print(text);
  
}
//**************************End of buttons***********************************************************
